#include <libgda/libgda.h>
#include <sql-parser/gda-sql-parser.h>

int main()
{
	gda_init();

	GError* error = NULL;
	GdaConnection* cnc = NULL;
	cnc = gda_connection_open_from_dsn ("SalesTest", NULL, GDA_CONNECTION_OPTIONS_NONE, &error);
	
	if (error) {
		g_warning("gda_connection_open_from_string() failed: %s\n", error->message);
		g_clear_error(&error);
		return 0;
	}

	GdaStatement *stmt;
	GdaSqlParser *parser = gda_sql_parser_new ();
	GdaDataModel *model;
	GdaSet *params;

	stmt = gda_sql_parser_parse_string (parser,
					    "SELECT * FROM customers WHERE id <= ##theid::gint",
					    NULL, NULL);
	g_object_unref (parser);
	gda_statement_get_parameters (stmt, &params, NULL);
	gda_set_set_holder_value (params, NULL, "theid", 5);
	model = gda_connection_statement_execute_select (cnc, stmt, params, &error);
	if (error) {
		g_warning("gda_connection_statement_execute_select() failed: %s\n", error->message);
		g_clear_error(&error);
		return 0;
	}
	g_object_set (G_OBJECT (model), "auto-reset", TRUE, NULL);
	g_object_unref (stmt);
	gda_data_model_dump (model, NULL);
	
	gda_set_set_holder_value (params, NULL, "theid", 9);
	gda_data_model_dump (model, NULL);

	return 0;
}
